<template>
  <div>
    <button class="btn bg-white capsule btn-sm mr-2" @click="showModal()">Resolve</button>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="600"
      v-if="selectedRoom"
    >
      <div class="container">
        <div class="row">
          <div class="col-md-12 text-center">
            <img
              :src="(selectedRoom) ? selectedRoom.created_by.picture || asset('images/pictures/no_avatar.jpg') : asset('/images/pictures/no_avatar.jpg')"
              alt="avatar"
              class="avatar-md avatar-custom"
            >
            <h5>{{ (selectedRoom) ? selectedRoom.created_by.name : ''}}</h5>
          </div>
          <div class="col-md-12 text-center">
            <b>Mark as resolved</b>
            <div class="form-group">
              <label>Resolve description</label>
              <textarea class="form-control" cols="30" rows="5" v-model="form.description"></textarea>
            </div>
          </div>
        </div>
        <div class="row justify-content-center">
          <div class="col-md-3">
            <button class="btn btn-block btn-primary capsule" @click="resolveLiveChat">Submit</button>
          </div>
          <div class="col-md-3">
            <button class="btn btn-block bg-light capsule" @click="hideModal">Cancel</button>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";
import * as httpHelper from "@/helpers/httpHelper";

import liveChatMixin from "@/mixins/LiveChatMixin";

export default {
  mixins: [liveChatMixin],
  data() {
    return {
      form: {
        description: null
      }
    };
  },
  props: ["selectedRoom"],
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    async resolveLiveChat() {
      this.hideModal();
      try {
        let response = await this.$axios.post(
          `api/${this.$store.getters.appId.hashed}/livechat/resolve`,
          {
            liveChatId: this.selectedRoom.livechat.id,
            agentId: this.$store.getters.localStorage.decodedUserId,
            description: this.form.description
          }
        );
        this.form.description = null;
        this.$store.dispatch("chat/liveChatUpdate", {
          room: this.selectedRoom,
          liveChat: response.data.data.liveChat,
          status: "resolved"
        });

        httpHelper.successToast(this, response.data.message);
      } catch (error) {
        httpHelper.errorToast(this, error);
      }
    }
  }
};
</script>
<style lang="scss" scoped>
</style>